package de.pereira.aqfinder;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import de.pereira.aqfinder.R;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

/**
 * @author Cliff
 *
 */
public class ChooseSearchString extends ListActivity {
	
	ArrayAdapter<String> adapter;
	int clickCounter=0;


	ArrayList<String> listItems=new ArrayList<String>();
	private boolean mExternalStorageWriteable;
	private boolean mExternalStorageAvailable;
	String filename = "searchTerms.txt";

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		checkExternalStorageAvailability();
		if (mExternalStorageAvailable) {
			File root = getExternalFilesDir(null);
			try {
				File searchTerms = new File(root, filename);
				if (!searchTerms.exists()) {
					searchTerms.createNewFile();
					Log.i("ChooseSearchString", "new file created in "+searchTerms.getAbsolutePath());
				}
				BufferedReader input =  new BufferedReader(new FileReader(searchTerms));
				String line;
				while ((line = input.readLine()) != null) {
					listItems.add(line);
				}
				input.close();
			} catch (IOException e) {
				Log.e("ChooseSearchString", "Error reading file on SD-Card: "+root.getAbsolutePath()+File.separator+filename+" " + e);
			}
		}
		
		setContentView(R.layout.choosesearchstring);

		adapter = new ArrayAdapter<String>(this, R.layout.list_item, R.id.listItemText, listItems);
		setListAdapter(adapter);

		ListView lv = getListView();
		lv.setTextFilterEnabled(true);

		lv.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				finish(((TextView) view).getText().toString());
			}

		});

	}
	
	
	
	/**
	 * Method is fired, when button is pressed to add a search term to the list
	 * @see chossesearchstring.xml
	 * @param v
	 */
	public void addItem(View v) {
		String searchTerm = ((EditText) findViewById(R.id.searchtextinput)).getText().toString();
		listItems.add(searchTerm);
		adapter.notifyDataSetChanged();
		
		if (mExternalStorageWriteable) {
			File root = getExternalFilesDir(null);
			File searchTermsFile = new File(root, filename);
			try {
			    FileWriter out = new FileWriter(searchTermsFile, true);
			    out.write(searchTerm+"\n");
			    Log.d("ChooseSearchStrin", "writing "+searchTerm+" to file");
			    out.close();
			}
			catch (IOException e) {
			    Log.e("ChooseSearchString", "Error writing to SD-Card in file: "+searchTermsFile.getAbsolutePath()+" " + e);
			}
		}
//		finish(searchTerm);
	}
	
	
	public void deleteItem (View v) {
		if (!listItems.isEmpty()) {
			System.out.println("löschen von "+((TextView) v).getText().toString());
			System.out.println("löschen von "+((Button) v).getText().toString());
		}
	}

	
	private void finish(String searchTerm){
		Bundle bundle = new Bundle();
		bundle.putString("searchTerm", searchTerm);
		Intent mIntent = new Intent();
		mIntent.putExtras(bundle);
		setResult(RESULT_OK, mIntent);
		finish();
	}
	
	
	private void checkExternalStorageAvailability(){
		String state = Environment.getExternalStorageState();

		if (Environment.MEDIA_MOUNTED.equals(state)) {
		    // We can read and write the media
		    mExternalStorageAvailable = mExternalStorageWriteable = true;
		} else if (Environment.MEDIA_MOUNTED_READ_ONLY.equals(state)) {
		    // We can only read the media
		    mExternalStorageAvailable = true;
		    mExternalStorageWriteable = false;
		} else {
		    // Something else is wrong. It may be one of many other states, but all we need
		    //  to know is we can neither read nor write
		    mExternalStorageAvailable = mExternalStorageWriteable = false;
		}
	}
}
