package de.pereira.aqfinder;

import java.io.IOException;

import org.apache.http.client.ClientProtocolException;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import de.pereira.aqfinder.model.SIRInformationObject;
import de.pereira.aqfinder.model.SensorItem;
import de.pereira.aqfinder.util.swe.CapabilitiesRequest;

public class SensorDetail extends Activity {
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Bundle b = getIntent().getExtras();
		
		final SIRInformationObject sirObject = (SIRInformationObject) b.getSerializable("sirObject");
		
		setContentView(R.layout.sensordetail);
		
		TextView sensorID = (TextView) findViewById(R.id.sensorID);
		sensorID.setText("Sensor ID: "+sirObject.getSensorID()+"\nSIR ID: "+sirObject.getSirID());
		
		TextView sensorService = (TextView) findViewById(R.id.sensorService);
		sensorService.setText("Sensor service: "+sirObject.getServiceType());
		
		TextView description = (TextView) findViewById(R.id.sensordescription);
		description.setText("Sensor description: \n"+sirObject.getSensorDescription());
		
		Button descriptionButton = (Button) findViewById(R.id.Full_Description);
		descriptionButton.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				Toast.makeText(getApplicationContext(), "This function is currently not supported.", 7000).show();
			}
		});
		
		Button back = (Button) findViewById(R.id.Button_Back);
		back.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				finish();
			}
		});
		
		Button data = (Button) findViewById(R.id.Data);
		data.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				SensorItem sensorItem = null;
				try {
					sensorItem = CapabilitiesRequest.parseGetCapabilitiesResponse(CapabilitiesRequest.makeGetCapabilitiesRequest(sirObject.getServiceURL()), sirObject.getSensorID());
				} catch (ClientProtocolException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if (sensorItem == null || sensorItem.getOfferings().length == 0) {
					Log.e("SensorDetails", "no offerings found");
					Toast.makeText(getApplicationContext(), "No offerings found. Please check whether the SOS is available.", 7000).show();
				} else {
					sensorItem.setServiceURL(sirObject.getServiceURL());
					Intent myIntent = new Intent(SensorDetail.this, ChooseData.class);
					Bundle b = new Bundle();
					b.putSerializable("sensorItem", sensorItem);
					myIntent.putExtras(b);
			        startActivity(myIntent);
					
				}
			}
		});
	}
}
