package de.pereira.aqfinder.listener;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;

import com.google.android.maps.GeoPoint;

import de.android1.overlaymanager.ManagedOverlay;
import de.android1.overlaymanager.ManagedOverlayItem;
import de.android1.overlaymanager.lazyload.LazyLoadCallback;
import de.android1.overlaymanager.lazyload.LazyLoadException;
import de.pereira.aqfinder.AQFinder;
import de.pereira.aqfinder.util.swe.SearchSensorRequest;

public class MyLazyLoadCallback implements LazyLoadCallback {
	
	private String searchTerm= null;
	private GeoPoint oldTopLeft = null;
	private GeoPoint oldBottomRight = null;
	private List<? extends ManagedOverlayItem> sensors = new ArrayList<ManagedOverlayItem>();

	
	public MyLazyLoadCallback(String searchTerm) {
		this.searchTerm = searchTerm;
	}

	
	@Override
	public List<? extends ManagedOverlayItem> lazyload(GeoPoint topLeft,
			GeoPoint bottomRight, ManagedOverlay arg2) throws LazyLoadException {
		// if zoomed do not perform a request
		if (oldTopLeft!= null && oldBottomRight!= null && isInOldBoundingBox(topLeft, bottomRight)) {
			return sensors;
		}
		
		// else perform a request
		HttpResponse response;
		try {
			response = SearchSensorRequest.makeSearchSensorRequest(AQFinder.SIR_URL, topLeft, bottomRight, searchTerm);
			sensors = SearchSensorRequest.parseSearchSensorRequestResponse(response);
			oldTopLeft = topLeft;
			oldBottomRight = bottomRight;
			return sensors;
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// in case of error
		// TODO Error Handling
		return new ArrayList<ManagedOverlayItem>();
	}

	private boolean isInOldBoundingBox(GeoPoint topLeft, GeoPoint bottomRight) {
		// TODO implement zoom check
		return false;
	}
	

}
