package de.pereira.aqfinder.model;

import java.io.Serializable;
import java.util.Date;

public class Offering implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6584798773167219101L;
	
	private String id;
	private String name;
	private String observedProperty;
	private String srsName;
	private Date start;
	private Date end;
	private String uom;
	
	
	public Offering(String id, String name, String observedProperty,
			String srsName, Date start, Date end) {
		super();
		this.id = id;
		this.name = name;
		this.observedProperty = observedProperty;
		this.srsName = srsName;
		this.start = start;
		this.end = end;
	}

	
	/**
	 * @return true if minimal requirements are given
	 */
	public boolean isValid(){
		return (observedProperty != null && id != null && name != null && srsName != null);
	}

	public Offering() {
		super();
	}


	public String getId() {
		return id;
	}


	public void setId(String id) {
		this.id = id;
	}


	public String getName() {
		return name;
	}


	public void setName(String name) {
		this.name = name;
	}


	public String getObservedProperty() {
		return observedProperty;
	}


	public void setObservedProperty(String observedProperty) {
		this.observedProperty = observedProperty;
	}


	public String getSrsName() {
		return srsName;
	}


	public void setSrsName(String srsName) {
		this.srsName = srsName;
	}


	public Date getStart() {
		return start;
	}


	public void setStart(Date start) {
		this.start = start;
	}


	public Date getEnd() {
		return end;
	}


	public void setEnd(Date end) {
		this.end = end;
	}


	public String getUom() {
		return uom;
	}


	public void setUom(String uom) {
		this.uom = uom;
	}
}
