package de.pereira.aqfinder.util;

import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

public class NetworkUtils {
	
	
	public static HttpResponse execute(String server, String xmlRequest)
			throws ClientProtocolException, IOException {
		StringEntity entity = new StringEntity(xmlRequest, "UTF-8");
		return execute(server, entity);
	}

	public static HttpResponse execute(String server, StringEntity entity)
			throws ClientProtocolException, IOException {
		HttpClient httpclient = NetworkUtils.getHttpClient();
		HttpPost httpPostCon = NetworkUtils.getHttpPostConnection(server, entity);
		return httpclient.execute(httpPostCon);
	}

	public static HttpClient getHttpClient() {
		return new DefaultHttpClient();
	}

	public static HttpPost getHttpPostConnection(String server,
			StringEntity entity) {
		HttpPost httppost = new HttpPost(server);
		httppost.addHeader("Accept", "application/xml");
		httppost.addHeader("Content-Type", "application/xml");
		httppost.setEntity(entity);
		return httppost;
	}
	
	public static Document httpResponseToDocument(HttpResponse response) throws IllegalStateException, SAXException, IOException, ParserConfigurationException {
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		return db.parse(response.getEntity().getContent());
	}
	
	
	
	
	
	
	// Example observedProperty
	// <sos:observedProperty xlink:href="http://giv-genesis.uni-muenster.de:8080/SOR/REST/phenomenon/OGC/Concentration/PM10"/>
//	private static String getExampleSIRResponse(){
//		return "<sir:SearchSensorResponse xsi:schemaLocation=\"http://swsl.uni-muenster.de/sir http://giv-genesis.uni-muenster.de/schemas/sir/sirAll.xsd http://www.opengis.net/sensorML/1.0.1 http://schemas.opengis.net/sensorML/1.0.1/sensorML.xsd\" xmlns:sir=\"http://swsl.uni-muenster.de/sir\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:ows=\"http://www.opengis.net/ows/1.1\">" +
//					"<sir:SearchResultElement>" +
//						"<sir:SensorIDInSIR>42</sir:SensorIDInSIR>" +
//						"<sir:SimpleSensorDescription>" +
//							"<sir:SensorDescriptionURL>http%3A%2F%2Fgiv-genesis.uni-muenster.de%3A8080%2FSIR%2Fsir%3Fservice%3DSIR%26amp%3Bversion%3D0.3.1%26amp%3BREQUEST%3DDescribeSensor%26amp%3BSENSORIDINSIR%3D42</sir:SensorDescriptionURL>" +
//							"<sir:DescriptionText>![CDATA[" +
//								"Identifications: urn:ogc:def:identifier:OGC:1.0:uniqueID - urn:ogc:object:feature:Sensor:EEA:airbase:4.0:DEBB003; urn:ogc:def:identifier:OGC:1.0:longName - Brandenburg a.d. Havel (alt); urn:ogc:def:identifier:OGC:1.0:shortName - Brandenburg a.d. Havel (alt);" +
//								"Classifications: intendedApplication - air quality; sensorType - Traffic; typeOfSensor - Traffic; stationOzoneType - urban; stationAreaType - urban; stationSubCatRural - unknown; streetType - Wide street: L/H &gt; 1.5;" +
//								"" +
//								"Keywords: BRANDENBURG; GERMANY; DE; AIRBASE; AIRQUALITY; EEA;" +
//								"" +
//								"]</sir:DescriptionText>" +
//							"<sir:ObservedBoundingBox crs=\"-1\" dimensions=\"2\">" +
//								"<ows:LowerCorner>52.41 12.544442</ows:LowerCorner>" +
//								"<ows:UpperCorner>52.41 12.544442</ows:UpperCorner>" +
//							"</sir:ObservedBoundingBox>" +
//						"</sir:SimpleSensorDescription>" +
//						"<sir:ServiceReference>" +
//							"<sir:ServiceURL>http://giv-uw.uni-muenster.de:8080/AQE/sos</sir:ServiceURL>" +
//							"<sir:ServiceType>SOS</sir:ServiceType>" +
//							"<sir:ServiceSpecificSensorID>urn:ogc:object:feature:Sensor:EEA:airbase:4.0:DEBB003</sir:ServiceSpecificSensorID>" +
//						"</sir:ServiceReference>" +
//					"</sir:SearchResultElement>" +
//				"</sir:SearchSensorResponse>";
//	}
}
